//+------------------------------------------------------------------+
//|                                                         iVAR.mq4 |
//|                                        (C)opyright  2008, Ilnur |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

//        , 
//      2^n.  
// ,         
// ,      .

// ..   . -     
//    .

#property copyright "(C)opyright  2008, Ilnur"
#property link      "http://www.metaquotes.net"
//----  
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Green
#property indicator_level1 0.5
#property indicator_level2 0.45
#property indicator_level3 0.55
//----  
extern int n = 5;
//extern int nBars = 1000;
//----  
double ibuffer[];
double ibuffer2[];
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
int init()
{
//----   
   SetIndexBuffer(0,ibuffer);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexDrawBegin(0,MathPow(2,n)+1);
   SetIndexLabel(0,"iVAR");
   SetIndexBuffer(1,ibuffer2);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexDrawBegin(1,MathPow(2,n)+1);
   SetIndexLabel(1,"iVARm");
   
//---- " "    
   IndicatorShortName("iVAR("+n+")");
   return(0);
}
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
int start()
{
   int i, j, kc, nTotal, nCountedBars = IndicatorCounted();
   int ihigh, ilow, nInterval;
   double Delta, X, Y, Sx, Sy, Sxx, Sxy;
//----     
   if(nCountedBars==0) nTotal = Bars-MathPow(2,n)-1;
   if(nCountedBars>0) nTotal = Bars-nCountedBars;
//----   
   for(j=nTotal; j>=0; j--)
   {
      Sx = 0; Sy = 0; Sxx = 0; Sxy = 0;
      for(i=0; i<=n; i++)
      {
         nInterval = MathPow(2,n-i);
         double x[];        double y[];
         ArrayResize(x, n+1); ArrayResize(y, n+1);
      //----        
         for(Delta=0, kc=0; kc<MathPow(2,i); kc++)
         {
            ihigh = iHighest(Symbol(),0,MODE_HIGH,nInterval,nInterval*kc+j);
            ilow = iLowest(Symbol(),0,MODE_LOW,nInterval,nInterval*kc+j);
            Delta += High[ihigh]-Low[ilow];
         }
      //----       
         X = (n-i)*MathLog(2.0);
         Y = MathLog(Delta);
         
         x[i]= (n-i)*MathLog(2.0);
         y[i]= MathLog(Delta);
      //----          
         Sx += X; 
         Sy += Y;
         Sxx += X*X; 
         Sxy += X*Y;
      }
   //----    (   )
   double a = -(Sx*Sy-(n+1)*Sxy)/(Sx*Sx-(n+1)*Sxx);
   double b =  (Sy - a*Sx)/(n+1);       
      ibuffer[j] = -(Sx*Sy-(n+1)*Sxy)/(Sx*Sx-(n+1)*Sxx);
    
   //  
   double k[];
   ArrayResize(k, n+1);
   
   //      
   double avgDev = 0;
   
   for (i = 0; i <= n; i++)
   {
      double value = y[i] - a*x[i] - b;
      avgDev += value*value;
   }
   
   avgDev /= n+1;
   
   //   
   for (i = 0; i <= n; i++)
   {
      value = y[i] - a*x[i] - b;
      k[i] = 0.5/(0.5+ value*value/avgDev);
   }

   //      
   double ek = 0;
   double ekx = 0;
   double eky = 0;
   double ekxx = 0;
   double ekxy = 0;
   
   for (i = 0; i <= n; i++)
   {
      ek    += k[i];
      ekx   += k[i]*x[i];
      eky   += k[i]*y[i];
      ekxx  += k[i]*x[i]*x[i];
      ekxy  += k[i]*x[i]*y[i];
   }

   // y = ax + b
   // counting a and b
   a = ekx*ekx - ekxx*ek;

   //   
   a = (eky*ekx - ek*ekxy)/a;
   b = (eky - a*ekx)/ek;   
   
   ibuffer2[j]=-a;
   
   }
   return(0);
}